'From Squeak 2.2 of Sept 23, 1998 on 13 October 1998 at 6:00:14 pm'!
"Change Set:		TuringMachines
Date:			9 October 1998
Author:			Your Name

"
Smalltalk at: #Graph ifAbsent: [(self inform: 'First you need to have Graph class installed.
take a look at http://www.sugarweb.com') halt]!

Object subclass: #Action
	instanceVariableNames: 'write move state '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Machines'!
Object subclass: #Condition
	instanceVariableNames: 'state value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Machines'!
Object subclass: #Tape
	instanceVariableNames: 'cell contents origin '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Machines'!
SimpleMorphicWrapper subclass: #TuringMachineMorphicWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Machines'!
SingleEdgedGraph subclass: #TuringProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Machines'!
TuringProgram subclass: #TuringMachine
	instanceVariableNames: 'tape state '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Machines'!
Object subclass: #TuringWeight
	instanceVariableNames: 'readValue action '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Machines'!

!Action commentStamp: '<historical>' prior: 0!
My instances are actions that may be performed by a Turing machine. Each action consists of a value to write, a state to change to and a movement to right or to the left of the tape's head.!

!Action methodsFor: 'comparing'!
= anAction
	" public - two actions are the same if they match in write value, state and movement"
	^self write = anAction write
	and: [self state = anAction state
	and: [self move = anAction move]]! !

!Action methodsFor: 'comparing' stamp: 'LC 11/22/97 12:02'!
hash
	^(self write hash + self state hash + self move hash) hash
! !

!Action methodsFor: 'accessing' stamp: 'LC 11/22/97 10:57'!
move
	^move! !

!Action methodsFor: 'accessing' stamp: 'LC 11/22/97 10:57'!
move: anInteger
	move _ anInteger! !

!Action methodsFor: 'accessing' stamp: 'LC 11/22/97 10:58'!
state
	^state! !

!Action methodsFor: 'accessing' stamp: 'LC 11/22/97 10:58'!
state: aSymbol
	state _ aSymbol! !

!Action methodsFor: 'accessing' stamp: 'LC 11/22/97 10:56'!
write
	^write
! !

!Action methodsFor: 'accessing' stamp: 'LC 11/22/97 10:57'!
write: aSymbol
	write _ aSymbol
! !

!Action methodsFor: 'printing'!
printOn: aStream
	" public - will show as '(write: aValue; state: aState; move: aMovement)'"
	aStream
		nextPutAll: '(write: ';
		nextPutAll: self write printString;
		nextPutAll: '; state: ';
		nextPutAll: self state printString;
		nextPutAll: '; move: ';
		nextPutAll: self move printString;
		nextPut: $) ! !


!Action class methodsFor: 'instance creation' stamp: 'LC 11/22/97 12:13'!
write: anObject state: aSymbol move: anInteger
	^self new write: anObject; state: aSymbol; move: anInteger! !


!Condition commentStamp: '<historical>' prior: 0!
My instances are conditions for the aplication of the action in a Rule. In a Turing machine a condition consists of a value and a state.!

!Condition methodsFor: 'comparing'!
= aCondition
	" public - Two conditions are the same if they match in value and state"
	^self value = aCondition value and: [self state = aCondition state]! !

!Condition methodsFor: 'comparing' stamp: 'LC 11/22/97 12:00'!
hash
	^(self value hash + self state hash) hash! !

!Condition methodsFor: 'accessing' stamp: 'LC 11/22/97 10:37'!
state
	^state! !

!Condition methodsFor: 'accessing' stamp: 'LC 11/22/97 10:37'!
state: aSymbol
	state _ aSymbol! !

!Condition methodsFor: 'accessing' stamp: 'LC 11/22/97 10:37'!
value
	^value! !

!Condition methodsFor: 'accessing' stamp: 'LC 11/22/97 10:37'!
value: aSymbol
	value _ aSymbol! !

!Condition methodsFor: 'evaluating'!
verifiesValue: anObject state: aSymbol
	" public - answer wether value anObject and state aSymbol satisfy me"
	^self value = anObject	and: [self state = aSymbol]! !

!Condition methodsFor: 'printing' stamp: 'r++ 10/9/1998 18:44'!
printOn: aStream
	" public - I will show up as '(aValue aState)'"
	aStream
		nextPut: $(;
		nextPutAll: self state printString;
		nextPutAll: ' ';
		nextPutAll: self value printString;
		nextPut: $)! !


!Condition class methodsFor: 'instance creation' stamp: 'r++ 1/17/98 20:26'!
state: aSymbol value: anObject
	^self new value: anObject; state: aSymbol! !

!Condition class methodsFor: 'instance creation' stamp: 'LC 11/22/97 12:11'!
value: anObject state: aSymbol
	^self new value: anObject; state: aSymbol! !


!Tape commentStamp: '<historical>' prior: 0!
My instances are recording tapes. A tape has cells and a read/write head. The head acts on the current cell by reading or writing objects on that cell. The tape can grow to the right and to the left. !

!Tape methodsFor: 'public'!
backward
	" public - move backward one position my read/write head"
	self cellPosition = 1
		ifTrue:
			[self contents addFirst: #nil.
			self origin: self origin + 1].
	self cell: self cell - 1! !

!Tape methodsFor: 'public'!
foreward
	" public - move foreward one position my read/write head"
	self cellPosition = self contents size ifTrue: [self contents add: #nil].
	self cell: self cell + 1! !

!Tape methodsFor: 'public'!
move: anInteger
	" public - 1 moves foreward, -1 moves backward, 0 no movement is done"
	anInteger = 0 ifTrue: [^ self].
	anInteger > 0
		ifTrue: [anInteger timesRepeat: [self foreward]]
		ifFalse: [anInteger negated timesRepeat: [self backward]]
! !

!Tape methodsFor: 'public' stamp: 'LC 11/22/97 19:56'!
playOn: aStream tempo: someMilliseconds
	| delay process note |
	delay _ Delay forMilliseconds: someMilliseconds.
	process _ [
		[(note _ self read) isNil] whileFalse:
			[delay wait.
			aStream nextPut: note.
			self foreward].
		delay unschedule].
	process forkAt: Processor userInterruptPriority! !

!Tape methodsFor: 'public'!
read
	" public - answer what my read write head is pointing at"
	^self contents at: self cellPosition! !

!Tape methodsFor: 'public'!
rewind
	" public - move my read write head to the starting position"
	self cell: 0! !

!Tape methodsFor: 'public' stamp: 'LC 11/22/97 19:58'!
showOnTranscriptTempo: someMilliseconds
	| delay process note |
	delay _ Delay forMilliseconds: someMilliseconds.
	process _ [
		[(note _ self read) isNil] whileFalse:
			[delay wait.
			Transcript nextPut: note; endEntry.
			self foreward].
		delay unschedule].
	process forkAt: Processor userInterruptPriority! !

!Tape methodsFor: 'public'!
write: anObject
	" public - write anObject to the place my read/write head is pointing to"
	^self contents at: self cellPosition put: anObject! !

!Tape methodsFor: 'private' stamp: 'LC 11/22/97 00:27'!
cell
	^cell! !

!Tape methodsFor: 'private' stamp: 'LC 11/22/97 00:27'!
cell: anInteger
	cell _ anInteger! !

!Tape methodsFor: 'private'!
cellPosition
	" private - answer the position of my cell in my content's Collection"
	^self cell + self origin! !

!Tape methodsFor: 'private' stamp: 'LC 11/22/97 00:26'!
contents
	^contents! !

!Tape methodsFor: 'private' stamp: 'LC 11/22/97 00:40'!
contents: aCollection 
	contents _ aCollection isEmpty
				ifTrue: [aCollection species with: nil]
				ifFalse: [aCollection]! !

!Tape methodsFor: 'private' stamp: 'LC 11/22/97 00:46'!
initialize
	self origin: 1.
	self rewind! !

!Tape methodsFor: 'private'!
origin
	" private - origin is the index of the starting position of my read/write head
	  in my content's collection, as elements are prepended to my contents, the origin
	  is incremented"
	^origin! !

!Tape methodsFor: 'private' stamp: 'LC 11/22/97 00:46'!
origin: anInteger
	origin _ anInteger! !

!Tape methodsFor: 'printing'!
printOn: aStream
	" public - I will whow up as 'anElement bElement [cElement] dElement ...',
	  the read/write head is pointing to cElement"
	| first |
	aStream nextPut: $(.
	first _ true.
	1 to: self contents size do: [:each |
		first ifTrue: [first _ false] ifFalse: [aStream nextPut: $ ].
		each = self cellPosition
			ifTrue:
				[aStream nextPut: $[.
				(self contents at: each) printOn: aStream.
				aStream nextPut: $]]
			ifFalse: [(self contents at: each) printOn: aStream]].
	aStream nextPut: $)
! !


!Tape class methodsFor: 'instance creation' stamp: 'LC 11/22/97 00:39'!
new
	^super new initialize! !

!Tape class methodsFor: 'instance creation'!
on: aCollection
	^self new contents: aCollection asOrderedCollection! !


!TuringMachine class reorganize!
('examples' adder example showExample)
!


!TuringMachine class methodsFor: 'examples' stamp: 'r++ 3/28/98 17:55'!
adder
	^ self new
		when: (Condition state: #start value: 0)
		do: (Action write: 0 state: 0 move: 1);
		
		when: (Condition state: #start value: 1)
		do: (Action write: 1 state: 1 move: 1);
		
		when: (Condition state: 0 value: 0)
		do: (Action write: 0 state: 2 move: 1);
		
		when: (Condition state: 0 value: 1)
		do: (Action write: 1 state: 3 move: 1 );

		when: (Condition state: 1 value: 0)
		do: (Action write: 0 state: 3 move: 1);

		when: (Condition state: 1 value: 1)
		do: (Action write: 1 state: 4 move: 1);

		when: (Condition state: 2 value: #nil)
		do: (Action write: 0 state: #halt move: 1);

		when: (Condition state: 3 value: #nil)
		do: (Action write: 1 state: #halt move: 1);

		when: (Condition state: 4 value: #nil)
		do: (Action write: 0 state: 3 move: 1);

		yourself.
! !

!TuringMachine class methodsFor: 'examples' stamp: 'r++ 10/9/1998 19:03'!
example
	^self new
		when: (Condition state: #start value: $a)
		do: (Action write: $A state: 2 move: 1);

		when: (Condition state: #start value: #nil)
		do: (Action write: #nil state: #halt move: 1);

		when: (Condition state: 2 value: $b)
		do: (Action write: $B state: 3 move: -1);

		when: (Condition state: 2 value: $B)
		do: (Action write: $B state: 2 move: 1);

		when: (Condition state: 2 value: $a)
		do: (Action write: $a state: 2 move: 1);

		when: (Condition state: 3 value: $A)
		do: (Action write: $A state: 5 move: 1);

		when: (Condition state: 3 value: $B)
		do: (Action write: $B state: 3 move: -1);

		when: (Condition state: 3 value: $a)
		do: (Action write: $a state: 4 move: -1);

		when: (Condition state: 4 value: $a)
		do: (Action write: $a state: 4 move: -1);

		when: (Condition state: 4 value: $A)
		do: (Action write: $A state: #start move: 1);

		when: (Condition state: 5 value: #nil)
		do: (Action write: #equalSizes state: #halt move: -1);

		when: (Condition state: 5 value: $b)
		do: (Action write: #differentSizes state: #halt move: -1);

		when: (Condition state: 5 value: $B)
		do: (Action write: $B state: 5 move: 1);

		input: 'aabbb';

		yourself
! !

!TuringMachine class methodsFor: 'examples'!
showExample
	| turing |
	turing _ TuringMachine example.
	turing input: 'aaaabbbb'.
	turing showDelay: 500.
! !


!TuringMachineMorphicWrapper commentStamp: '<historical>' prior: 0!
I'm the morphic representation of a TuringMachine!

!TuringMachineMorphicWrapper methodsFor: 'initialization'!
initialize
	super initialize.
	self stopStepping! !

!TuringMachineMorphicWrapper methodsFor: 'stepping'!
step
	" public - 'step' option in doubleClickMenu,
	  make a single step on my assosiated TuringMachine"
	self object step.
	self updateContents.
	self object state = #halt ifTrue: [self stopStepping]
! !

!TuringMachineMorphicWrapper methodsFor: 'stepping'!
stepTime
	" 1 sec. - may be changed for a choice menu, but this is a faster interface"
	^ 1000! !

!TuringMachineMorphicWrapper methodsFor: 'stepping' stamp: 'Gerardo Richarte 11/23/97 21:24'!
wantsSteps
	" don't let the world control my stepping, I will do it (and my menu)"
	^ false! !

!TuringMachineMorphicWrapper methodsFor: 'menus'!
doubleClickMenu: evt
	" add 'run' and 'stop' options to my doubleClickMenu"
	^ (super doubleClickMenu: evt)
		addLine;
		add: 'run'
			target: self
			selector: #startStepping
			argumentList: #();
		add: 'stop'
			target: self
			selector: #stopStepping
			argumentList: #()! !

!TuringMachineMorphicWrapper methodsFor: 'menus'!
droppingMenu: aMorph event: evt
	" add 'run with it' option to droppingMenu"
	^ (super droppingMenu: aMorph event: evt)
		addLine;
		add: 'run with it'
			target: self
			selector: #runIt:
			argumentList: {aMorph}! !

!TuringMachineMorphicWrapper methodsFor: 'menus'!
runIt: anInputObject
	" 'run with it' droppingMenu option.
	  run my turing with anInputObject as input"
	anInputObject delete.
	self object input: anInputObject object.
	self startStepping! !


!TuringProgram commentStamp: '<historical>' prior: 0!
My instances are programs for Turing machines. You can ask them it's states and dictionary!

!TuringProgram methodsFor: 'accessing' stamp: 'r++ 10/9/1998 18:48'!
actions
	" public - answer a Set off al the actions I can take"
	^ self weights collect: [:eachWeight | eachWeight action]! !

!TuringProgram methodsFor: 'accessing' stamp: 'r++ 10/9/1998 18:47'!
conditions
	" public - answer a Set off al the conditions I understand"
	^ (self edges collect: [:eachEdge | Condition state: eachEdge from name value: eachEdge weight readValue]) asSet! !

!TuringProgram methodsFor: 'accessing' stamp: 'Gerardo Richarte 11/23/97 19:23'!
dictionary
	" public - answer the Set of all output and input values I can produce and understand"
	^ self inputDictionary addAll: self outputDictionary ; yourself! !

!TuringProgram methodsFor: 'accessing' stamp: 'r++ 10/9/1998 18:32'!
inputDictionary
	" public - answer the Set of all input values I understand"
	^ Set new addAll: (self weights collect: [:eachWeight | eachWeight readValue]).
! !

!TuringProgram methodsFor: 'accessing' stamp: 'r++ 10/9/1998 19:46'!
inputStates
	" public - answer the Set of all posible states from which I can take an action from"
	^ (self conditions collect: [:eachCondition | eachCondition state]) asSet.
! !

!TuringProgram methodsFor: 'accessing' stamp: 'r++ 10/9/1998 18:34'!
outputDictionary
	" public - answer the Set of all output values I can produce"
	^ Set new addAll: (self weights collect: [:eachWeight | eachWeight writeValue]).
! !

!TuringProgram methodsFor: 'accessing' stamp: 'r++ 10/9/1998 19:46'!
outputStates
	" public - answer the Set of all posible state which I can take an action to"
	^ (self actions collect: [:eachActions | eachActions state]) asSet.! !

!TuringProgram methodsFor: 'accessing'!
states
	" public - answer all posible states in which I can be, that's all I understand as a Condition
	  or all I can answer as an Action"
	^ self inputStates addAll: self outputStates; yourself! !

!TuringProgram methodsFor: 'programing' stamp: 'r++ 10/9/1998 18:55'!
when: aCondition do: anAction
	" public - add the given rule to the program.	r++ 1/17/98 16:26"
	^ self addArrowFrom: aCondition state
		to: anAction state
		weighted: (
			TuringWeight
				whenRead: aCondition value
				do: anAction)! !

!TuringProgram methodsFor: 'executing' stamp: 'r++ 10/9/1998 17:50'!
apply: aCondition
	" public - if there's a proper rule, answer the Action corresponding to aCondition,
	  otherway answer nil"
	| competentArrow |
	aCondition state = #halt ifTrue: [^ Action write: aCondition value state: #halt move: 0].
	competentArrow _ (self vertexForName: aCondition state) arrows detect: [:one |
		 one weight readValue = aCondition value].
	^Action
		write: competentArrow weight writeValue
		state: competentArrow to
		move: competentArrow weight movement.
! !


!TuringMachine commentStamp: '<historical>' prior: 0!
My instances are Turing machines. A Turing machine may be programmed and the program may be run on some input. The programming language consists of rule. A program may loop forever or end by change movng into state #halt.
Once a program is loaded in the machine, a set of data can be used as input by sending the message #input: to the machine.

	see example and adder for some examples on how to program a TuringMachine.

	Or if you want to Type TuringMachine example (on en WrapperWorldMorph) and press enter.!
]style[(322 6 23 7 5 5 143)f1,f1LTuringMachine input:;,f1,f1LTuringMachine class example. TuringMachine class adder;,f1,f1LTuringMachine class example. TuringMachine class adder;,f1!

!TuringMachine reorganize!
('initialization' initializeState initializeTape)
('accessing' morphicWrapperClass state state: tape tape:)
('data loading' input:)
('executing' move: read step write:)
('printing' printOn: showDelay: showOn:delay:)
('converting' asProgram)
!


!TuringMachine methodsFor: 'initialization' stamp: 'r++ 10/9/1998 19:34'!
initializeState
	" start in #halt state"
	self state: (self vertexForName: #halt).
! !

!TuringMachine methodsFor: 'initialization'!
initializeTape
	" start with an almost empty Tape.
	  The #nil (insted) of nil is becouse Set (for #dictionary) doesn't allow addition of nil"
	self input: #( #nil )! !

!TuringMachine methodsFor: 'accessing' stamp: 'r++ 10/9/1998 17:50'!
morphicWrapperClass
	" public - outliner interface. Answer my best outliner's Class"
	^ Smalltalk at: #TuringMachineMorphicWrapper! !

!TuringMachine methodsFor: 'accessing'!
state
	" public - answer my current state"
	state ifNil: [self initializeState].
	^state! !

!TuringMachine methodsFor: 'accessing'!
state: aSymbol
	" set my current state. My be using for debugging a TuringProgram"
	state _ aSymbol! !

!TuringMachine methodsFor: 'accessing'!
tape
	tape ifNil: [self initializeTape].
	^ tape! !

!TuringMachine methodsFor: 'accessing' stamp: 'LC 11/22/97 11:05'!
tape: aTape
	tape _ aTape! !

!TuringMachine methodsFor: 'data loading' stamp: 'r++ 10/9/1998 19:33'!
input: aCollection
	" public - load data in my Tape, and change state to #start, so step method will work fine"
	self tape: (Tape on: aCollection).
	self state: (self vertexForName: #start)
! !

!TuringMachine methodsFor: 'executing'!
move: anInteger
	" public - Move my Tape's read/write head
	  forward the message to my Tape"
	self tape move: anInteger! !

!TuringMachine methodsFor: 'executing'!
read
	" public - Read what my Tape's read/write head is pointing to.
	  forward the message to my Tape"
	^self tape read! !

!TuringMachine methodsFor: 'executing' stamp: 'r++ 10/9/1998 19:32'!
step
	| action |
	action _ self apply: (Condition value: self read state: self state).
	self
		write: action write;
		state: action state;
		move: action move.
! !

!TuringMachine methodsFor: 'executing'!
write: anObject
	" public - Write an Object to my Tape's.
	  forward the message to my Tape"
	self tape write: anObject! !

!TuringMachine methodsFor: 'printing'!
printOn: aStream
	" public - I will show up in two lines, first containing 'state: aState',
	  and second showing my Tape"
	aStream nextPutAll: 'state: ', self state printString; cr.
	self tape printOn: aStream ! !

!TuringMachine methodsFor: 'printing' stamp: 'Gerardo Richarte 11/23/97 08:20'!
showDelay: aDelayTime
	| process delay |
	delay _ Delay forMilliseconds: aDelayTime.
	process _ 
		[[Transcript show: self printString; cr.
		self state = #halt] whileFalse: [delay wait. self step].
		delay unschedule] newProcess.
	process priority: Processor userInterruptPriority.
	process resume! !

!TuringMachine methodsFor: 'printing' stamp: 'Gerardo Richarte 11/23/97 08:20'!
showOn: aStream delay: aDelayTime
	| process delay |
	delay _ Delay forMilliseconds: aDelayTime.
	process _ 
		[[aStream nextPutAll: self printString; cr.
		self state = #halt] whileFalse: [delay wait. self step].
		delay unschedule] newProcess.
	process priority: Processor userInterruptPriority.
	process resume! !

!TuringMachine methodsFor: 'converting' stamp: 'r++ 1/17/98 20:38'!
asProgram
	^ TuringProgram new vertices: self vertices! !


!TuringWeight reorganize!
('initialization' whenRead:do:)
('accessing' movement readValue writeValue)
('printing' printOn:)
('as yet unclassified' action)
!


!TuringWeight methodsFor: 'initialization' stamp: 'r++ 10/9/1998 18:50'!
whenRead: readV do: anAction
	readValue _ readV.
	action _ anAction! !

!TuringWeight methodsFor: 'accessing' stamp: 'r++ 10/9/1998 18:55'!
movement
	^action move! !

!TuringWeight methodsFor: 'accessing' stamp: 'r++ 1/17/98 20:29'!
readValue
	^readValue! !

!TuringWeight methodsFor: 'accessing' stamp: 'r++ 10/9/1998 18:55'!
writeValue
	^action write! !

!TuringWeight methodsFor: 'printing' stamp: 'r++ 1/17/98 20:37'!
printOn: aStream
	aStream nextPutAll: '(whenRead: '.
	self readValue printOn: aStream.
	aStream nextPutAll: ' doWrite: '.
	self writeValue printOn: aStream.
	aStream nextPutAll: ' andMove: '.
	self movement printOn: aStream.
	aStream nextPut: $).! !

!TuringWeight methodsFor: 'as yet unclassified' stamp: 'r++ 10/9/1998 19:24'!
action
	^ action! !


!TuringWeight class methodsFor: 'instance creation' stamp: 'r++ 10/9/1998 18:50'!
whenRead: readValue do: anAction
	" public - creates and answers a new TuringWieght
	  whos readValue, writeValue and movement are those given.	r++ 1/17/98 16:19"
	^ self new
		whenRead: readValue
		do: anAction! !


